From 943b301f68db7c29387b1a8ce546d7dc9c5f4506 Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Wed, 27 Jan 2010 21:30:06 +0100
Subject: [PATCH 10/11] Use VLC_FEATURE everywhere.


Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac |  533 +++++++++++++++++++++++++---------------------------------
 1 files changed, 228 insertions(+), 305 deletions(-)

diff --git a/configure.ac b/configure.ac
index 1a8ac63..5011221 100644
--- a/configure.ac
+++ b/configure.ac
@@ -201,8 +201,7 @@ case "${host_os}" in
     VLC_ADD_LDFLAGS([libvlccore],[-Wl,-framework,CoreFoundation])
     AC_ARG_ENABLE(macosx-defaults,
       AS_HELP_STRING([--enable-macosx-defaults],[Build the default configuration on Mac OS X (default enabled)]))
-    if test "x${enable_macosx_defaults}" != "xno"
-    then
+    AS_IF([VLC_FEATURE_NOT_DISABLED([macosx-defaults])], [
         echo ""
         echo "Building with Mac OS X defaults:"
         with_macosx_version_min="10.5"
@@ -226,7 +225,7 @@ case "${host_os}" in
         VLC_FEATURE_FORCE_ENABLE([asademux])
         VLC_FEATURE_FORCE_DISABLE([skins2])
         VLC_FEATURE_FORCE_DISABLE([xcb])
-    fi
+    ])
     dnl
     dnl  Check for Mac OS X SDK settings
     dnl
@@ -313,10 +312,9 @@ case "${host_os}" in
         dnl
         AC_ARG_ENABLE(peflags,
           [  --enable-peflags        peflags use (default enabled on Windows)])
-        if test "${enable_peflags}" != "no"
-        then
+        AS_IF([VLC_FEATURE_NOT_DISABLED([peflags])], [
           AC_CHECK_TOOL(PEFLAGS, peflags, :)
-        fi
+        ])
     fi
     if test "${SYS}" = "mingwce"; then
         # add ws2 for closesocket, select, recv
@@ -358,7 +356,7 @@ AM_CONDITIONAL(HAVE_DARWIN, test "${SYS}" = "darwin")
 AM_CONDITIONAL(HAVE_LINUX, [test "${SYS}" = "linux"])
 AM_CONDITIONAL(HAVE_WIN32, test "${SYS}" = "mingw32")
 AM_CONDITIONAL(HAVE_WINCE, test "${SYS}" = "mingwce")
-AM_CONDITIONAL(USE_PEFLAGS, [test "${enable_peflags}" = "yes"])
+AM_CONDITIONAL(USE_PEFLAGS, [VLC_FEATURE_ENABLED([peflags])])
 
 dnl
 dnl Sadly autoconf doesn't think about testing foo.exe when ask to test
@@ -397,7 +395,7 @@ m4_defun([AC_DEPLIBS_CHECK_METHOD],[])
 
 lt_cv_deplibs_check_method=pass_all
 
-AS_IF([test "${enable_shared}" = "no"], [
+AS_IF([VLC_FEATURE_DISABLED([shared])], [
   AC_MSG_ERROR([VLC is based on plugins. Shared libraries cannot be disabled.])
 ])
 
@@ -500,7 +498,7 @@ AC_PREPROC_IFELSE([
   AC_MSG_RESULT([not present])
 ], [
   AC_MSG_RESULT([found])
-  AS_IF([test "x${enable_nls}" != "xno" || test "x${enable_mozilla}" != "xno"], [
+  AS_IF([VLC_FEATURE_NOT_DISABLED([nls]) || VLC_FEATURE_NOT_DISABLED([mozilla])], [
     AC_MSG_ERROR([Buggy GNU/libc (version 2.5 - 2.7) present. VLC would crash; there is no viable
 work-around for this. Check with your distribution vendor on how to update the
 glibc run-time. Alternatively, build with --disable-nls --disable-mozilla and
@@ -901,8 +899,7 @@ AC_ARG_ENABLE(dbus,
   [  --enable-dbus           Linux D-BUS message bus system (default enabled)])
 case "${SYS}" in
     linux*|*bsd*)
-if test "${enable_dbus}" != "no" -a "${SYS}" != "mingw32" -a "${SYS}" != "mingwce"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dbus]) && test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce"], [
   dnl api stable dbus
   PKG_CHECK_MODULES(DBUS, dbus-1 >= 1.0.0,
     [ AC_DEFINE( HAVE_DBUS, 1, [Define if you have the D-BUS library] )
@@ -910,20 +907,19 @@ then
       VLC_ADD_CFLAGS([libvlccore],[$DBUS_CFLAGS])
       dnl Check for dbus control interface
         AC_ARG_ENABLE(dbus-control, [  --disable-dbus-control  D-BUS control interface (default enabled)])
-        if test "${enable_dbus_control}" != "no"
-        then
+        AS_IF([VLC_FEATURE_NOT_DISABLED([dbus_control])], [
           VLC_ADD_PLUGIN([dbus])
           VLC_ADD_LIBS([dbus],[$DBUS_LIBS])
           VLC_ADD_CFLAGS([dbus],[$DBUS_CFLAGS])
-        fi
+        ])
       dnl Check for Telepathy
         AC_ARG_ENABLE(telepathy,
           AS_HELP_STRING([--enable-telepathy],[Telepathy Presence plugin through DBus(default enabled)]))
-        if test "${enable_telepathy}" != "no"; then
+        AS_IF([VLC_FEATURE_NOT_DISABLED([telepathy])], [
           VLC_ADD_PLUGIN([telepathy])
           VLC_ADD_LIBS([telepathy],[$DBUS_LIBS])
           VLC_ADD_CFLAGS([telepathy],[$DBUS_CFLAGS])
-        fi
+        ])
         dnl Power Management Inhibiter
         VLC_ADD_PLUGIN([inhibit])
         VLC_ADD_LIBS([inhibit],[$DBUS_LIBS])
@@ -931,7 +927,7 @@ then
     ],
     [AC_MSG_ERROR([Couldn't find DBus >= 1.0.0, install libdbus-dev ?])]
   )
-fi
+])
 ;;
 esac
 
@@ -951,8 +947,8 @@ RDC_PROG_CC_WFLAGS([all extra sign-compare undef pointer-arith bad-function-cast
 RDC_PROG_CC_FLAGS([-pipe])
 
 AC_ARG_ENABLE(warnings-as-error,
-      AS_HELP_STRING([--enable-warnings-as-error],[Treat acceptable warnings as error (default disabled)]),, [enable_warnings_as_error="no"])
-AS_IF([test "${enable_warnings_as_error}" = "yes"], [
+      AS_HELP_STRING([--enable-warnings-as-error],[Treat acceptable warnings as error (default disabled)]))
+AS_IF([VLC_FEATURE_ENABLED([warnings-as-error])], [
     RDC_PROG_CC_WERRORFLAGS([unused-function unused-label unused-value unused-parameter unused-variable unused \
      missing-braces nonnull parentheses uninitialized address enum-compare undef comment switch \
      bad-function-cast implicit sequence-point strict-aliasing array-bounds missing-parameter-type \
@@ -1514,9 +1510,9 @@ dnl  Memory usage
 dnl
 AC_ARG_ENABLE(optimize-memory,
 [  --enable-optimize-memory optimize memory usage over performance])
-if test "${enable_optimize_memory}" = "yes"; then
+AS_IF([VLC_FEATURE_ENABLED([optimize-memory])], [
   AC_DEFINE(OPTIMIZE_MEMORY, 1, Define if you want to optimize memory usage over performance)
-fi
+])
 
 dnl
 dnl  Enable/disable optimizations
@@ -1553,7 +1549,7 @@ dnl Allow runing as root (usefull for people runing on embedded platforms)
 dnl
 AC_ARG_ENABLE(run-as-root,
 [  --enable-run-as-root    allow runing VLC as root (default disabled)])
-AS_IF([test "${enable_run_as_root}" = "yes"],[
+AS_IF([VLC_FEATURE_ENABLED([run-as-root])], [
     AC_DEFINE(ALLOW_RUN_AS_ROOT, 1,
               [Define to 1 to allow runing VLC as root (uid 0).])
 ])
@@ -1585,7 +1581,7 @@ dnl Stream output
 dnl
 AC_ARG_ENABLE(sout,
   [  --enable-sout           Stream output modules (default enabled)])
-AS_IF([test "${enable_sout}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
   AC_DEFINE(ENABLE_SOUT, 1, [Define to 1 for stream output support.])
 ])
 AM_CONDITIONAL(ENABLE_SOUT, [test "${enable_sout}" != "no"])
@@ -1594,8 +1590,7 @@ dnl Lua modules
 AC_ARG_ENABLE(lua,
   AS_HELP_STRING([--enable-lua],[lua playlist, metafetcher and interface
 		  plugins (default enabled)]))
-if test "${enable_lua}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([lua])], [
   PKG_CHECK_MODULES(LUA, lua5.1,
     [ have_lua=yes ],
     [
@@ -1614,7 +1609,7 @@ then
             AC_CHECK_LIB( lua , luaL_newstate,
               [LUA_LIBS="-llua"],
               [ have_lua=no
-                AS_IF([test "x${enable_lua}" = "xyes"],
+                AS_IF([VLC_FEATURE_REQUESTED([lua])], 
                   [AC_MSG_ERROR([lua >= 5.1 not found!])],
                   [AC_MSG_WARN([lua >= 5.1 not found!])])
               ], [-lm])
@@ -1628,7 +1623,7 @@ then
   else
       AC_MSG_ERROR([Could not find lua. Lua is needed for some interfaces (rc, telnet, http) as well as many other custom scripts. Use --disable-lua to ignore this error.])
   fi
-fi
+])
 AM_CONDITIONAL(BUILD_LUA, [test "${have_lua}" = "yes"])
 
 dnl
@@ -1636,25 +1631,24 @@ dnl HTTP daemon
 dnl
 AC_ARG_ENABLE(httpd,
   [  --enable-httpd          HTTP daemon (default enabled)])
-if test "${enable_httpd}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([httpd])], [
   VLC_ADD_PLUGIN([oldhttp])
   AC_DEFINE(ENABLE_HTTPD, 1, Define if you want the HTTP dameon support)
-fi
-AM_CONDITIONAL(BUILD_HTTPD, [test "${enable_httpd}" != "no"])
+])
+AM_CONDITIONAL(BUILD_HTTPD, [VLC_FEATURE_NOT_DISABLED([httpd])])
 
 dnl
 dnl libproxy support
 dnl
 AC_ARG_ENABLE(libproxy,
   [  --enable-libproxy       libproxy support (default auto)])
-AS_IF([test "${enable_libproxy}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([libproxy])], [
   PKG_CHECK_MODULES(LIBPROXY, libproxy-1.0, [
     AC_DEFINE(HAVE_LIBPROXY, 1, [Define if libproxy is available])
     VLC_ADD_CFLAGS([access_http],[$LIBPROXY_CFLAGS])
     VLC_ADD_LIBS([access_http],[$LIBPROXY_LIBS])
   ], [
-    AS_IF([test "x${enable_libproxy}" != "x"], [
+    AS_IF([VLC_FEATURE_REQUESTED([libproxy])], [
       AC_MSG_ERROR([libproxy could not be found on your system])
     ])
   ])
@@ -1668,7 +1662,7 @@ VLC_FEATURE_DEFAULT([vlm], ["${enable_sout}"])
 AC_ARG_ENABLE(vlm,
   [  --enable-vlm            VideoLAN manager (default enabled)])
 AS_IF([VLC_FEATURE_NOT_DISABLED([vlm])], [
-  AS_IF([test "${enable_sout}" = "no"], [
+  AS_IF([VLC_FEATURE_DISABLED([sout])], [
     AC_MSG_ERROR([VLM requires the stream output. Do not use --disable-sout.])
   ])
   AC_DEFINE(ENABLE_VLM, 1, [Define if you want the VideoLAN manager support])
@@ -1702,7 +1696,7 @@ dnl
 
 AC_ARG_ENABLE(audioscrobbler,
   [  --disable-audioscrobbler Last.fm submission plugin (default enabled)])
-AS_IF([test "${enable_audioscrobbler}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([audioscrobbler])], [
         VLC_ADD_PLUGIN([audioscrobbler])
   ])
 
@@ -1711,7 +1705,7 @@ dnl Taglibplugin
 dnl
 AC_ARG_ENABLE(taglib,
   [  --disable-taglib        Taglib support (default enabled) ])
-  AS_IF([test "${enable_taglib}" != "no"],[
+  AS_IF([VLC_FEATURE_NOT_DISABLED([taglib])], [
     PKG_CHECK_MODULES(TAGLIB, taglib >= 1.5,
       [ VLC_ADD_PLUGIN([taglib])
         VLC_ADD_LIBS([taglib],[$TAGLIB_LIBS -lz])
@@ -1729,7 +1723,7 @@ dnl  live555 input
 dnl
 AC_ARG_ENABLE(live555,
 [  --enable-live555        live555 RTSP input plugin (default enabled)])
-if test "${enable_live555}" != "no"; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([live555])], [
   AC_ARG_WITH(live555-tree,
     [  --with-live555-tree=PATH live.com tree for static linking])
 
@@ -1837,12 +1831,12 @@ lternatively you can use --disable-live555 to disable the liveMedia plugin.])
     else
       dnl  The given live555 wasn't built
         AC_MSG_RESULT(no)
-      if test "${enable_live555}" = "yes"; then
+      AS_IF([VLC_FEATURE_REQUESTED([live555])], [
         AC_MSG_ERROR([cannot find ${real_live555_tree}/liveMedia/libliveMedia.a, make sure you compiled live555 in ${with_live555_tree}])
-      fi	
+      ])
     fi
   fi
-fi
+])
 
 dnl
 dnl - special access module for dc1394 input
@@ -1856,8 +1850,7 @@ dnl dvdread module: check for libdvdread
 dnl
 AC_ARG_ENABLE(dvdread,
 [  --enable-dvdread        dvdread input module (default enabled)])
-if test "${enable_dvdread}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dvdread])], [
   AC_ARG_WITH(dvdread,
   [  --with-dvdread=PATH     libdvdread headers and libraries])
   AC_ARG_WITH(dvdread-tree,
@@ -1880,10 +1873,9 @@ then
             [ VLC_ADD_PLUGIN([dvdread])
 	      VLC_ADD_LIBS([dvdread],[-ldvdread ${LIBS_dvdcss}])
 	    ],[
-	      if test -n "${enable_dvdread}"
-	      then
+        AS_IF([VLC_FEATURE_REQUESTED([dvdread])], [
 	      AC_MSG_ERROR([cannot find libdvdread headers])
-	     fi
+	     ])
 	   ])
 	])
     else
@@ -1923,15 +1915,14 @@ then
       AC_MSG_ERROR([cannot find ${with_dvdread}/include/dvdread/dvd_reader.h])
     fi
   fi
-fi
+])
 
 dnl
 dnl  libdvdnav plugin
 dnl
 AC_ARG_ENABLE(dvdnav,
   [  --enable-dvdnav         dvdnav input module (default enabled)])
-if test "${enable_dvdnav}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dvdnav])], [
   dnl Same hack than dvdread
   if test "${SYS}" = "mingw32" || test "${SYS}" = "darwin" || test "${SYS}" = "beos" ; then
       VLC_ADD_LIBS([dvdnav],[-ldvdcss])
@@ -1951,15 +1942,14 @@ then
     VLC_ADD_CFLAGS([dvdnav],[`${DVDNAV_CONFIG} --cflags`])
     VLC_ADD_LIBS([dvdnav],[`${DVDNAV_CONFIG} --libs`])
   fi
-fi
+])
 
 dnl
 dnl  Windows DirectShow access module
 dnl
 AC_ARG_ENABLE(dshow,
   [  --enable-dshow          Win32 DirectShow support (default enabled on Win32)])
-if test "${enable_dshow}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dshow])], [
   if test "${SYS}" = "mingw32"
   then
     AC_LANG_PUSH(C++)
@@ -1969,7 +1959,7 @@ then
         VLC_ADD_LIBS([dshow],[-lole32 -loleaut32 -luuid]) ])
     AC_LANG_POP(C++)
   fi
-fi
+])
 
 dnl
 dnl  Windows DirectShow BDA access module
@@ -1977,8 +1967,7 @@ dnl
 AC_ARG_ENABLE(bda,
   AS_HELP_STRING([--enable-bda],[Win32 DirectShow BDA support (default
 		  enabled on Win32)]))
-if test "${enable_bda}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([bda])], [
   if test "${SYS}" = "mingw32"
   then
       AC_CHECK_HEADERS(dshow.h,
@@ -1986,7 +1975,7 @@ then
         VLC_ADD_CXXFLAGS([bda],[])
         VLC_ADD_LIBS([bda],[-lstrmiids -lole32 -loleaut32 -luuid]) ])
   fi
-fi
+])
 
 
 dnl
@@ -1994,8 +1983,7 @@ dnl  OpenCV wrapper and example filters
 dnl
 AC_ARG_ENABLE(opencv,
   [  --enable-opencv         OpenCV (computer vision) filter (default disabled)])
-if test "${enable_opencv}" = "yes" -a "${CXX}" != "";
-then
+AS_IF([VLC_FEATURE_ENABLED([opencv]) && test "${CXX}" != ""], [
   AC_ARG_WITH(opencv-tree,
   [  --with-opencv-tree=PATH opencv tree for linking])
     if test "${SYS}" = "mingw32"
@@ -2030,7 +2018,7 @@ then
         [AC_MSG_ERROR([libopencv not found!])]
       )
     fi
-fi
+])
 
 
 dnl
@@ -2038,14 +2026,14 @@ dnl  libsmbclient plugin
 dnl
 AC_ARG_ENABLE(smb,
   [  --enable-smb            smb input module (default enabled)])
-if test "${enable_smb}" != "no"; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([smb])], [
   AC_CHECK_HEADERS(libsmbclient.h,
     [ VLC_ADD_PLUGIN([access_smb])
       VLC_ADD_LIBS([access_smb],[-lsmbclient]) ],
-    [ if test -n "${enable_smb}"; then
+    [ AS_IF([VLC_FEATURE_REQUESTED([smb])], [
         AC_MSG_ERROR([cannot find libsmbclient headers])
-     fi ])
-fi
+     ]) ])
+])
 
 
 dnl
@@ -2053,12 +2041,12 @@ dnl sftp access support
 dnl
 AC_ARG_ENABLE(sftp,
   [  --enable-sftp           sftp input access module (default disable)])
-if test "${enable_sftp}" = "yes"; then
+AS_IF([VLC_FEATURE_ENABLED([sftp])], [
   AC_CHECK_HEADERS(libssh2.h, [
     VLC_ADD_PLUGIN([access_sftp])
     VLC_ADD_LIBS([access_sftp], [-lssh2])
   ])
-fi
+])
 
 dnl
 dnl  libdvbpsi ts demux/mux
@@ -2066,8 +2054,7 @@ dnl
 AC_ARG_ENABLE(dvbpsi,
   [  --enable-dvbpsi         dvbpsi ts mux and demux module (default enabled)])
 have_dvbpsi=no
-if test "${enable_dvbpsi}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
   AC_ARG_WITH(dvbpsi,
   [  --with-dvbpsi=PATH      libdvbpsi headers and libraries])
   AC_ARG_WITH(dvbpsi,
@@ -2078,9 +2065,9 @@ then
     then
       AC_CHECK_HEADERS(dvbpsi/dr.h,
         [ VLC_ADD_PLUGIN([ts])
-          if test "${enable_sout}" != "no"; then
+          AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
             VLC_ADD_PLUGIN([mux_ts])
-          fi
+          ])
           VLC_ADD_LIBS([mux_ts ts dvb],[-ldvbpsi])
 	  have_dvbpsi=yes],
         [  AC_MSG_WARN([cannot find libdvbpsi headers]) ],
@@ -2107,9 +2094,9 @@ then
         dnl  Use a custom libdvbpsi
         AC_MSG_RESULT(${real_dvbpsi_tree}/src/.libs/libdvbpsi.a)
         VLC_ADD_PLUGIN([ts])
-        if test "${enable_sout}" != "no"; then
+        AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
           VLC_ADD_PLUGIN([mux_ts])
-        fi
+        ])
         VLC_ADD_CPPFLAGS([mux_ts ts dvb],[-I${real_dvbpsi_tree}/src])
         VLC_ADD_LIBS([mux_ts ts dvb],[${real_dvbpsi_tree}/src/.libs/libdvbpsi.a])
 	have_dvbpsi=yes
@@ -2136,18 +2123,17 @@ then
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_test}"
     AC_CHECK_HEADERS([dvbpsi/dr.h],[
       VLC_ADD_PLUGIN([ts])
-      if test "${enable_sout}" != "no"; then
+      AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
         AC_CHECK_LIB(dvbpsi, dvbpsi_SDTServiceAddDescriptor,
            [VLC_ADD_PLUGIN([mux_ts])], [], [${LDFLAGS_test} -ldvbpsi])
-      fi
+      ])
       VLC_ADD_CPPFLAGS([mux_ts ts dvb],[${CPPFLAGS_test}])
       VLC_ADD_LIBS([mux_ts ts dvb],[${LDFLAGS_test} -ldvbpsi])
       have_dvbpsi=yes
     ],[
-      if test -n "${enable_dvbpsi}"
-      then
+      AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
         AC_MSG_ERROR([Could not find libdvbpsi on your system: you may get it from www.videolan.org, you'll need at least version 0.1.6])
-      fi
+      ])
     ],
     [#if defined( HAVE_STDINT_H )
 #   include <stdint.h>
@@ -2165,15 +2151,14 @@ then
     AC_DEFINE(HAVE_DVBPSI_SDT, 1, [Define if you have dvbpsi_GenSDTSections.])
   ], [], [${LIBS_ts}])
 
-fi
+])
 
 dnl
 dnl  Video4Linux plugin
 dnl
 AC_ARG_ENABLE(v4l,
   [  --enable-v4l            Video4Linux input support (default disabled)])
-if test "${enable_v4l}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([v4l])], [
   AC_ARG_WITH(v4l,
     [  --with-v4l=PATH         path to a v4l-enabled kernel tree],[],[])
   if test "${with_v4l}" != "no" -a -n "${with_v4l}"
@@ -2186,30 +2171,28 @@ then
     VLC_ADD_PLUGIN([v4l])
   ],[])
   CPPFLAGS="${CPPFLAGS_save}"
-fi
+])
 
 dnl
 dnl libv4l1 support for video4linux.
 dnl
 AC_ARG_ENABLE( libv4l,
   [  --enable-libv4l         Libv4l Video4Linux support (default enabled)])
-if test "${enable_libv4l}" != "no" -a "${enable_v4l}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l]) && VLC_FEATURE_NOT_DISABLED([v4l])], [
     PKG_CHECK_MODULES( LIBV4L, libv4l1, [
       VLC_ADD_LDFLAGS([v4l],[${LIBV4L_LIBS}])
       VLC_ADD_CFLAGS([v4l],[${LIBV4L_CFLAGS}])
       AC_DEFINE(HAVE_LIBV4L1, 1, Define if libv4l is available)],
       AC_MSG_WARN([LibV4L support disabled because libv4l development headers were not found])
     )
-fi
+])
 
 dnl
 dnl  Video4Linux2 plugin
 dnl
 AC_ARG_ENABLE(v4l2,
   [  --enable-v4l2           Video4Linux2 input support (default enabled)])
-if test "${enable_v4l2}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([v4l2])], [
   AC_ARG_WITH(v4l2,
     [  --with-v4l2=PATH        path to a v4l2-enabled kernel tree],[],[])
   if test "${with_v4l2}" != "no" -a -n "${with_v4l2}"
@@ -2222,30 +2205,28 @@ then
     VLC_ADD_PLUGIN([v4l2])
   ],[])
   CPPFLAGS="${CPPFLAGS_save}"
-fi
+])
 
 dnl
 dnl libv4l2 support for video4linux.
 dnl
 AC_ARG_ENABLE( libv4l2,
   [  --enable-libv4l2        Libv4l2 Video4Linux2 support (default enabled)])
-if test "${enable_libv4l2}" != "no" -a "${enable_v4l2}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l2]) && VLC_FEATURE_NOT_DISABLED([v4l2])], [
     PKG_CHECK_MODULES( LIBV4L2, libv4l2, [
       VLC_ADD_LDFLAGS([v4l2],[${LIBV4L2_LIBS}])
       VLC_ADD_CFLAGS([v4l2],[${LIBV4L2_CFLAGS}])
       AC_DEFINE(HAVE_LIBV4L2, 1, Define if libv4l2 is available)],
       AC_MSG_WARN([LibV4L2 support disabled because libv4l2 development headers were not found])
     )
-fi
+])
 
 dnl
 dnl  special access module for Hauppauge PVR cards
 dnl
 AC_ARG_ENABLE(pvr,
   [  --enable-pvr            PVR cards access module (default disabled)])
-if test "${enable_pvr}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([pvr])], [
   VLC_ADD_PLUGIN([pvr])
   AC_ARG_WITH(videodev2,
     [  --with-videodev2=FILE   Location of videodev2.h file (default /usr/include/linux/videodev2.h)],[],[])
@@ -2270,7 +2251,7 @@ then
   if test "${ac_cv_new_linux_videodev2_h}" != "no"; then
     AC_DEFINE(HAVE_NEW_LINUX_VIDEODEV2_H, 1, [Define if new linux/videodev2.h present])
   fi
-fi
+])
 
 dnl
 dnl  gnomeVFS access module
@@ -2303,8 +2284,7 @@ AC_ARG_ENABLE(vcd,
 AC_ARG_ENABLE(libcddb,
   [  --enable-libcddb        CDDB support for libcdio audio CD (default enabled)])
 
-if test "${enable_vcd}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([vcd])], [
   AC_MSG_CHECKING(for cdrom_msf0 in linux/cdrom.h)
   AC_EGREP_HEADER(cdrom_msf0,linux/cdrom.h,[
     AC_MSG_RESULT(yes)
@@ -2343,7 +2323,7 @@ then
     VLC_ADD_LIBS([vcdx cdda],[-liconv])
   fi
 
-  if test "$enable_libcddb" != "no"; then
+  AS_IF([VLC_FEATURE_NOT_DISABLED([libcddb])], [
     PKG_CHECK_MODULES(LIBCDDB, libcddb >= 0.9.5, [
       HAVE_LIBCDDB=yes
       AC_DEFINE(HAVE_LIBCDDB, 1, [Define this if you have libcddb installed])
@@ -2352,17 +2332,15 @@ then
       ],:
       [AC_MSG_WARN(new enough libcddb not found. CDDB access disabled)
       HAVE_LIBCDDB=no])
-  fi
-fi
+  ])
+])
 
 dnl
 dnl  DVB-S/DVB-T/DVB-C satellite/teresterial/cable input using v4l2
 dnl
 AC_ARG_ENABLE(dvb,
   [  --enable-dvb            DVB-S/T/C card support (default enabled)])
-
-if test "${enable_dvb}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([dvb])], [
     AS_IF([test "${have_dvbpsi}" = "yes" ],[
     AC_ARG_WITH(dvb,
      [  --with-dvb=PATH         path to a dvb- and v4l2-enabled kernel tree],[],[])
@@ -2378,14 +2356,14 @@ then
    ],[
      AC_MSG_WARN([the dvb access module requires libdvbpsi])
     ])
-fi
+])
 
 dnl
 dnl  Screen capture module
 dnl
 AC_ARG_ENABLE(screen,
   [  --enable-screen         Screen capture support (default enabled)])
-if test "${enable_screen}" != "no"; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([screen])], [
   if test "${SYS}" = "darwin"; then
     AC_CHECK_HEADERS(OpenGL/gl.h, [
       AC_CHECK_HEADERS(ApplicationServices/ApplicationServices.h, [
@@ -2403,7 +2381,7 @@ if test "${enable_screen}" != "no"; then
     VLC_ADD_CXXFLAGS([screen],[])
     VLC_ADD_LIBS([screen],[-lbe])
   fi
-fi
+])
 
 dnl
 dnl  ipv6 plugin
@@ -2425,21 +2403,21 @@ dnl
 dnl  ogg demux plugin
 dnl
 PKG_ENABLE_MODULES_VLC([OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
-if test "${enable_sout}" != "no"; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
     PKG_ENABLE_MODULES_VLC([MUX_OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
-fi
+])
 
-if test "${enable_sout}" != "no"; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
 dnl Check for libshout
 PKG_ENABLE_MODULES_VLC([SHOUT], [access_output_shout], [shout >= 2.1], [libshout output plugin], [auto])
-fi
+])
 
 dnl
 dnl  matroska demux plugin
 dnl
 AC_ARG_ENABLE(mkv,
   [  --enable-mkv            Matroska demux support (default enabled)])
-if test "${enable_mkv}" != "no" -a "${CXX}" != ""; then
+AS_IF([VLC_FEATURE_NOT_DISABLED([mkv]) && test "${CXX}" != ""], [
   AC_LANG_PUSH(C++)
   AC_CHECK_HEADERS(ebml/EbmlVersion.h, [
     AC_MSG_CHECKING(for libebml version >= 0.7.7)
@@ -2486,15 +2464,14 @@ if test "${enable_mkv}" != "no" -a "${CXX}" != ""; then
     ])
   ])
   AC_LANG_POP(C++)
-fi
+])
 
 dnl
 dnl  modplug demux plugin
 dnl
 AC_ARG_ENABLE(mod,
   [  --enable-mod            Mod demux support (default enabled)])
-if test "${enable_mod}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([mod])], [
   AC_ARG_WITH(mod-tree,
   [  --with-mod-tree=PATH    mod tree for static linking])
   if test -n "${with_mod_tree}"
@@ -2526,30 +2503,28 @@ then
           VLC_ADD_LIBS([mod],[$LIBMODPLUG_LIBS])
         ],[AC_MSG_WARN([libmodplug not found!])])
   fi
-fi
+])
 
 dnl
 dnl  mpc demux plugin
 dnl
 AC_ARG_ENABLE(mpc,
   [  --enable-mpc            Mpc demux support (default enabled)])
-if test "${enable_mpc}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([mpc])], [
   AC_CHECK_HEADERS([mpc/mpcdec.h], [
     VLC_ADD_PLUGIN([mpc])
     VLC_ADD_LIBS([mpc],[-lmpcdec])],
     [AC_CHECK_HEADERS([mpcdec/mpcdec.h], [
     VLC_ADD_PLUGIN([mpc])
     VLC_ADD_LIBS([mpc],[-lmpcdec])])])
-fi
+])
 
 dnl
 dnl  game music emu demux plugin
 dnl
 AC_ARG_ENABLE(gme,
   [  --enable-gme            Game Music Emu demux support (default enabled)])
-if test "${enable_gme}" != "no" -a "${CXX}" != "";
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([gme]) && test "${CXX}" != ""], [
   AC_LANG_PUSH(C++)
   AC_ARG_WITH(gme-tree,
   [  --with-gme-tree=PATH    gme tree for static linking])
@@ -2579,7 +2554,7 @@ then
       AC_MSG_WARN([only static linking is available, you must provide a gme-tree])
   fi
   AC_LANG_POP(C++)
-fi
+])
 
 dnl
 dnl  Codec plugins
@@ -2592,28 +2567,25 @@ dnl wmafixed plugin
 dnl
 AC_ARG_ENABLE(wma-fixed,
   [  --enable-wma-fixed      libwma-fixed module (default disabled)])
-if test "${enable_wma_fixed}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([wma-fixed])], [
   VLC_ADD_PLUGIN([wma_fixed])
-fi
+])
 
 dnl
 dnl shine fixed point mp3 encoder
 dnl
 AC_ARG_ENABLE(shine,
   [  --enable-shine          shine mp3 encoding module (default disabled)])
-if test "${enable_shine}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([shine])], [
   VLC_ADD_PLUGIN([shine])
-fi
+])
 
 dnl
 dnl  mad plugin
 dnl
 AC_ARG_ENABLE(mad,
   [  --enable-mad            libmad module (default enabled)])
-if test "${enable_mad}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([mad])], [
   AC_ARG_WITH(mad,
     [  --with-mad=PATH         path to libmad],[],[])
   if test "${with_mad}" != "no" -a -n "${with_mad}"
@@ -2663,14 +2635,14 @@ then
     CPPFLAGS="${CPPFLAGS_save}"
     LDFLAGS="${LDFLAGS_save}"
   fi
-fi
+])
 
 dnl
 dnl   libid3tag support (FIXME!!! doesn't work with new input)
 dnl
 AC_ARG_ENABLE( id3tag,
 [  --disable-id3tag        id3tag metadata reader plugin (default disabled)])
-AS_IF([test "${enable_id3tag}" = "yes"], [
+AS_IF([VLC_FEATURE_ENABLED([id3tag])], [
   AC_CHECK_HEADERS(id3tag.h, [
       AS_IF([test "${have_zlib}" = "yes"],[
           VLC_ADD_LIBS([id3tag],[-lid3tag -lz])
@@ -2680,18 +2652,15 @@ AS_IF([test "${enable_id3tag}" = "yes"], [
 ])
 
 AC_ARG_ENABLE(merge-ffmpeg,
-[  --enable-merge-ffmpeg   merge FFmpeg-based plugins (default disabled)],, [
-  enable_merge_ffmpeg="no"
-])
-AM_CONDITIONAL([MERGE_FFMPEG], [test "$enable_merge_ffmpeg" != "no"])
+[  --enable-merge-ffmpeg   merge FFmpeg-based plugins (default disabled)])
+AM_CONDITIONAL([MERGE_FFMPEG], [AS_IF([VLC_FEATURE_ENABLED([ffmpeg])])])
 
 dnl
 dnl  avcodec decoder/encoder plugin
 dnl
 AC_ARG_ENABLE(avcodec,
 [  --enable-avcodec        libavcodec codec (default enabled)])
-if test "${enable_avcodec}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([avcodec])], [
   PKG_CHECK_MODULES(AVCODEC,[libavcodec >= 51.48.0 libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2707,7 +2676,7 @@ then
     ],[
       AC_MSG_ERROR([Could not find libavcodec or libavutil. Use --disable-avcodec to ignore this error.])
   ])
-fi
+])
 
 dnl
 dnl libva needs avcodec
@@ -2715,8 +2684,8 @@ dnl
 AC_ARG_ENABLE(libva,
   [  --enable-libva          libva VAAPI support (default auto)])
 
-AS_IF([test "${enable_libva}" != "no"], [
-  AS_IF([test "x${have_avcodec}" = "xyes"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([libva])], [
+  AS_IF([VLC_FEATURE_ENABLED([avcodec])], [
     PKG_CHECK_MODULES(LIBVA, [libva libva-x11],
       [
         VLC_SAVE_FLAGS
@@ -2728,19 +2697,19 @@ AS_IF([test "${enable_libva}" != "no"], [
            AC_DEFINE(HAVE_AVCODEC_VAAPI, 1, [Define if avcodec has to be built with VAAPI support.])
            echo "VAAPI acceleration activated"
         ],[
-	AS_IF([test "${enable_libva}" == "yes"],
+	AS_IF([VLC_FEATURE_REQUESTED([libva])],
 	      [AC_MSG_ERROR([libva is present but libavcodec/vaapi.h is missing])],
               [AC_MSG_WARN([libva is present but libavcodec/vaapi.h is missing ])])
         ])
         VLC_RESTORE_FLAGS
       ],[
-	AS_IF([test "${enable_libva}" == "yes"],
+	AS_IF([VLC_FEATURE_REQUESTED([libva])],
               [AC_MSG_ERROR([Could not find required libva.])],
               [AC_MSG_WARN([libva not found  ])])
       ])
   ],[
-    AS_IF([test "x${enable_libva}" != "x"], [
-      AC_MSG_ERROR([--enable-libva and --disable-avcodec options are mutually exclusive.])
+    AS_IF([VLC_FEATURE_REQUESTED([libva])], [
+      AC_MSG_ERROR([--enable-libva needs a working avcodec.])
     ])
   ])
 ])
@@ -2750,8 +2719,7 @@ dnl dxva2 needs avcodec
 dnl
 AC_ARG_ENABLE(dxva2,
   [  --enable-dxva2          DxVA2  support (default auto)])
-
-AS_IF([test "${enable_dxva2}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([dxva2])], [
   if test "${SYS}" = "mingw32"; then
   AS_IF([test "x${have_avcodec}" = "xyes"], [
     AC_CHECK_HEADERS(dxva2api.h, 
@@ -2761,18 +2729,18 @@ AS_IF([test "${enable_dxva2}" != "no"], [
            AC_DEFINE(HAVE_AVCODEC_DXVA2, 1, [Define if avcodec has to be built with DxVA2 support.])
            echo "DxVA2 acceleration activated"
         ],[
-	AS_IF([test "${enable_dxva2}" == "yes"],
+	AS_IF([VLC_FEATURE_REQUESTED([dxva2])],
 	      [AC_MSG_ERROR([dxva2 is present but libavcodec/dxva2.h is missing])],
               [AC_MSG_WARN([dxva2 is present but libavcodec/dxva2.h is missing ])])
         ])
       ],[
-	AS_IF([test "${enable_dxva2}" == "yes"],
+	AS_IF([VLC_FEATURE_REQUESTED([dxva2])],
               [AC_MSG_ERROR([Could not find required dxva2api.h])],
               [AC_MSG_WARN([dxva2api.h not found])])
       ])
   ],[
-    AS_IF([test "x${enable_dxva2}" != "x"], [
-      AC_MSG_ERROR([--enable-dxva2 and --disable-avcodec options are mutually exclusive.])
+    AS_IF([VLC_FEATURE_REQUESTED([dxva2])], [
+      AC_MSG_ERROR([--enable-dxva2 needs a working avcodec.])
     ])
   ])
   fi
@@ -2784,7 +2752,7 @@ dnl stream_out switcher needs libavcodec
 dnl
 AC_ARG_ENABLE(switcher,
   [  --enable-switcher       Stream-out switcher plugin (default disabled)])
-AS_IF([test "${enable_switcher}" = "yes"], [
+AS_IF([VLC_FEATURE_ENABLED([switcher])], [
   AS_IF([test "x${have_avcodec}" = "xyes"], [
     VLC_ADD_PLUGIN([stream_out_switcher])
     VLC_ADD_LIBS([stream_out_switcher],[$AVCODEC_LIBS $AVUTIL_LIBS])
@@ -2800,8 +2768,7 @@ dnl
 
 AC_ARG_ENABLE(avformat,
 [  --enable-avformat       libavformat containers (default enabled)])
-if test "${enable_avformat}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([avformat])], [
   PKG_CHECK_MODULES(AVFORMAT,[libavformat libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2809,7 +2776,7 @@ then
       CFLAGS="${CFLAGS} ${AVFORMAT_CFLAGS}"
       AC_CHECK_HEADERS(libavformat/avformat.h ffmpeg/avformat.h)
       AC_CHECK_HEADERS(libavutil/avutil.h ffmpeg/avutil.h)
-      AS_IF([test "$enable_merge_ffmpeg" = "no"], [
+      AS_IF([VLC_FEATURE_NOT_ENABLED([merge-ffmpeg])], [
         VLC_ADD_PLUGIN([avformat access_avio])
         VLC_ADD_LIBS([avformat access_avio],[$AVFORMAT_LIBS $AVUTIL_LIBS])
         VLC_ADD_CFLAGS([avformat access_avio],[$AVFORMAT_CFLAGS $AVUTIL_CFLAGS])
@@ -2821,7 +2788,7 @@ then
     ],[
       AC_MSG_ERROR([Could not find libavformat or libavutil. Use --disable-avformat to ignore this error.])
   ])
-fi
+])
 
 dnl
 dnl  swscale image scaling and conversion plugin
@@ -2830,8 +2797,7 @@ dnl
 AC_ARG_ENABLE(swscale,
   AS_HELP_STRING([--enable-swscale],[libswscale image scaling and conversion
 		  (default enabled)]))
-if test "${enable_swscale}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([swscale])], [
   PKG_CHECK_MODULES(SWSCALE,[libswscale],
     [
       VLC_SAVE_FLAGS
@@ -2845,7 +2811,7 @@ then
     ],[
       AC_MSG_ERROR([Could not find libswscale. Use --disable-swscale to ignore this error. Proper software scaling and some video chroma conversion will be missing.])
   ])
-fi
+])
 
 dnl
 dnl  postproc plugin
@@ -2853,8 +2819,7 @@ dnl
 
 AC_ARG_ENABLE(postproc,
 [  --enable-postproc       libpostproc image post-processing (default enabled)])
-if test "${enable_postproc}" != "no"
-then
+AS_IF([VLC_FEATURE_NOT_DISABLED([postproc])], [
   PKG_CHECK_MODULES(POSTPROC,[libpostproc libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2868,7 +2833,7 @@ then
     ],[
       AC_MSG_ERROR([Could not find libpostproc. Use --disable-postproc to ignore this error.])
   ])
-fi
+])
 
 dnl
 dnl  faad decoder plugin
@@ -2927,7 +2892,7 @@ dnl  QuickTime plugin
 dnl
 AC_ARG_ENABLE(quicktime,
   [  --enable-quicktime      QuickTime module (deprecated)])
-if test "${enable_quicktime}" = "yes"; then
+AS_IF([VLC_FEATURE_ENABLED([quicktime])], [
   if test "${SYS}" = "mingw32"; then
     VLC_ADD_PLUGIN([quicktime])
   else
@@ -2936,16 +2901,16 @@ if test "${enable_quicktime}" = "yes"; then
       VLC_ADD_LDFLAGS([quicktime],[-Wl,-framework,QuickTime,-framework,Carbon])
     ], [ AC_MSG_ERROR([cannot find QuickTime headers]) ])
   fi
-fi
+])
 
 dnl
 dnl  Real plugin
 dnl
 AC_ARG_ENABLE(real,
   [  --enable-real           Real media module (default disabled)])
-if test "${enable_real}" = "yes"; then
+AS_IF([VLC_FEATURE_ENABLED([real])], [
   VLC_ADD_PLUGIN([realvideo])
-fi
+])
 
 dnl
 dnl  Real RTSP plugin
